#include "jni.h"       /* where everything is defined */
#include <stdlib.h>
#define __USE_GNU
#include <unistd.h>

int main(int argc, char* argv[])
{
 JavaVM *jvm;       /* denotes a Java VM */
 JNIEnv *env;       /* pointer to native method interface */
 JavaVMInitArgs vm_args; /* JDK/JRE 6 VM initialization arguments */
 jthrowable obj;
 JavaVMOption options[2];
 char buf[127];

 char *curdir = get_current_dir_name();
 sprintf(buf, "-Djava.class.path=%s", curdir);
 free(curdir);
 options[0].optionString = buf;
 //options[1].optionString = (char *)"-verbose";
 options[1].optionString = "-Dguff";

 vm_args.version = JNI_VERSION_1_6;
 vm_args.nOptions = 2;
 vm_args.options = options;
 vm_args.ignoreUnrecognized = 0;
 /* load and initialize a Java VM, return a JNI interface
  * pointer in env */
 puts("Initializing VM..");
 JNI_CreateJavaVM(&jvm, (void**)&env, &vm_args);
 //sleep(15);
 
 /* invoke the Main.test method using the JNI */
 jclass cls = (*env)->FindClass(env, "Main");
 jmethodID mid = (*env)->GetStaticMethodID(env, cls, "test", "(I)V");
 (*env)->CallStaticVoidMethod(env, cls, mid, 100);

 /* invoke an exception in Exception class itself */
 jclass excls = (*env)->FindClass(env, "java/lang/Exception");
 printf("Exception class pointer at: %p\n", excls);
 (*env)->ThrowNew(env, excls, "thrown by M.Isa from vm.c");
 (*env)->ExceptionDescribe(env);
 /* We are done. */
 (*jvm)->DestroyJavaVM(jvm);
}
